public class A4Comparator implements A4Node {

  // Ein Thread zur Berechnung des Vergleichs
  private CompareThread t = null;

  // ein 2-elementiges Array für die zu vergleichenden Werte
  private int[] vals;

  //gibt für jeden Wert in vals an, ob er gesetzt wurde
  private boolean[] valsSet;

  // Nachfolger im Netzwerk
  private A4Consumer minConsumer, maxConsumer;

  //Indizes der Eingänge der Nachfolger im Netzwerk
  private int minConsumerInputIndex, maxConsumerInputIndex;

//-----------------------------------------------------------------------------

  // der Thread vergleicht die Werte und gibt sie an die Nachfolger
  private class CompareThread extends Thread {
    public void run() {
      minConsumer.setInputValue(minConsumerInputIndex, Math.min(vals[0], vals[1]));
      maxConsumer.setInputValue(maxConsumerInputIndex, Math.max(vals[0], vals[1]));
    }
  }

//-----------------------------------------------------------------------------

  public A4Comparator() {
    t = new CompareThread();
    vals = new int[2];
    valsSet = new boolean[2];
  }

  //Empfangen der Werte. Sind beide empfangen,wird die Weiterbearbeitung gestartet
  public void setInputValue(int inputIndex, int value) {
    vals[inputIndex] = value;
    valsSet[inputIndex] = true;
    if (valsSet[0] && valsSet[1]) t.start();
  }

  //Methode zum Anmelden der Nachfolger
  public void setOutputConnection(int outputIndex, A4Consumer cons, int consumerInputIndex) {
    //System.out.println(this+".setOutputConn("+outputIndex+", "+cons+", "+consumerInputIndex+") [1]");
    switch (outputIndex) {
      case 0:
        minConsumer = cons;
        minConsumerInputIndex = consumerInputIndex;
        break;
      case 1:
        maxConsumer = cons;
        maxConsumerInputIndex = consumerInputIndex;
        break;
      default: 
        throw new IndexOutOfBoundsException("illegal index for 1-Merger: "+consumerInputIndex);
    }
  }
}