public class A4Merger implements A4Node {
  
  //Merger für die beiden Teillisten
  private A4Node m0 = null;
  private A4Node m1 = null;

  //die Komparatorstufe
  private A4Comparator[] comparators = null;

  //Länge jeder der Eingabefolgen
  private int n;

  public A4Merger(int n) {
    if (n <= 1) throw new IllegalArgumentException("n must be greater than 1");
    this.n = n;
    
    if (n > 2) {
      m0 = new A4Merger (n >> 1);
      m1 = new A4Merger (n >> 1);
    }
    else {
      m0 = new A4Comparator();
      m1 = new A4Comparator();
    }

    comparators = new A4Comparator[n-1];
    for (int i = 0; i< comparators.length; i++)
      comparators[i] = new A4Comparator();

    //Verbindungen von m1 zu den Komparatoren
    for (int i = 1; i < n; i++) 
      m0.setOutputConnection(i, comparators[i-1], 0);
    //Verbindungen von m2 zu den Komparatoren
    for (int i = 1; i < n; i++) 
      m1.setOutputConnection(i - 1, comparators[i-1], 1);

  }

  //Ein eEingabewert wird an den richtigen Merger geleitet
  public void setInputValue(int inputIndex, int value) {
    if ((inputIndex & 1) == 0) m0.setInputValue(inputIndex >> 1, value);
    else m1.setInputValue((inputIndex >> 1), value);
  }

  //Verbindungen an die Outports werden an die Komparatoren oder (bei min/max) an einen Merger
  //weitergereicht
  public void setOutputConnection(int outputIndex, A4Consumer cons, int consumerInputIndex) {
    //System.out.println(this+".setOutputConn("+outputIndex+", "+cons+", "+consumerInputIndex+") ["+n+"]");
    if (outputIndex == 0) m0.setOutputConnection(0, cons, consumerInputIndex);
    else if (outputIndex == (n << 1) - 1) m1.setOutputConnection(n - 1, cons, consumerInputIndex);
    else comparators[(outputIndex - 1) >> 1].setOutputConnection((outputIndex & 1) ^ 1, cons, consumerInputIndex);
  }
}